// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "PrefabComponentParser.hpp"
#include "PrefabChildParser.hpp"

namespace Dawn {
  struct Prefab {
    struct PrefabRegistry *registry;
    struct PrefabChild root;
    std::string name;
    std::string type;
  };
  
  class PrefabParser : public XmlParser<struct Prefab> {
    protected:
      std::vector<std::string> getRequiredAttributes() override;
      std::map<std::string, std::string> getOptionalAttributes() override;
      int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct Prefab *out,
        std::string *error
      ) override;
  };
}